****************************************************************************
****************************************************************************
**
**  Mercury (Specific enemy control code)
**
**  This software is in the public domain.  There is no warranty.
**
**  by Patrick Davidson (pad@calc.org, http://pad.calc.org/)
**
**  Last updated May 17, 2002
**
****************************************************************************
****************************************************************************

*************************************** EXPLODING ENEMY

E_EXPLODING:
        bchg    #0,e_timer(a4)
        beq.s   \done
        bsr     Next_Sprite
        bge.s   \done
        clr.w   (a4)
\done:  rts

*************************************** ENEMY 3 (LIGHTNING LAUNCHER)

E_ENEMY_3:
        moveq   #100,d0
        bsr     random
        tst.w   d0
        bne.s   \ns
        lea     \lightning(pc),a1
        bsr     Fire_Generic_Bullet
\ns:    sub.w   #16,e_x(a4)
        bge.s   \ok
        clr.w   (a4)
\ok:    rts

\lightning:
        dc.w    EB_SIMPLE,4,-2<<4,13,3<<4,6,splightning-Draw_Sprite,0,-48,0

*************************************** ENEMY 4 (NORMAL HOLDING)

E_ENEMY_4_ENTERING:
        addq.w  #1,e_misc(a4)
        beq.s   \done_entering
        move.w  e_misc(a4),d0
        cmp.w   #-32,d0
        bge.s   \not_too_fast
        moveq   #-32,d0
\not_too_fast:
        add.w   d0,e_x(a4)
        bra.s   E_ENEMY_4_MAIN
\done_entering:
        move.w  #ENEMY_4_MAIN,(a4)

E_ENEMY_4_MAIN:
        move.w  e_timer(a4),d0
        addq.w  #2,d0
        move.w  d0,e_timer(a4)
        bsr     sin_cos
        asr.w   #3,d0
        add.w   e_y2(a4),d0
        move.w  d0,e_y(a4)

        moveq   #127,d0
        bsr     random
        tst.w   d0
        bne.s   \r
        lea     enemy_2_shot(pc),a1
        bra     Fire_Generic_Bullet
\r:     rts

*************************************** ENEMY 2 (SWOOPING)

E_ENEMY_2:
        sub.w   #32,e_x(a4)
        blt.s   \kill
        cmp.w   #208<<4,e_x(a4)
        bgt.s   \r
        move.w  e_misc(a4),d0
        cmp.w   #8,d0
        beq.s   \final
        addq.w  #1,d0
        move.w  d0,e_misc(a4)
\final: add.w   d0,e_y(a4)
        blt.s   \kill

        moveq   #110,d0
        bsr     random
        tst.w   d0
        bne.s   \r
        lea     enemy_2_shot(pc),a1
        bra     Fire_Generic_Bullet

\kill:  clr.w   (a4)
\r:     rts

enemy_2_shot:
        dc.w    EB_SIMPLE,2,-5<<4,9,4<<4,4,spbullet_2-Draw_Sprite,0,-48,0

*************************************** LIGHTNING CANNON

E_HEAVY_CANNON:
        tst.w   open_space(a5)
        bne.s   \s
        sub.w   #16,e_x(a4)
        blt.s   \kill

\s:     move.w  game_timer(a5),d0
        and.w   #63,d0
        bne.s   \done

        lea     \lightning(pc),a1
        clr.w   18(a1)
        move.w  player_yc(a5),d0
        sub.w   e_y(a4),d0
        cmp.w   #30<<4,d0
        blt.s   \ok
        move.w  #16,18(a1)
\ok:    bra     Fire_Generic_Bullet

\done:  rts

\kill:  clr.w   (a4)
        rts

\lightning:
        dc.w    EB_SIMPLE,6,-2<<4,13,3<<4,6,splightning-Draw_Sprite,0,-48,0

*************************************** TANK

E_ARTILLERY:
        move.w  e_x(a4),d2
        sub.w   #16,d2

        cmp.w   #150<<4,d2
        bne.s   \a
        GETSPR  artillery_1,e_image(a4)
        addq.w  #2,e_misc(a4)
        sub.w   #1<<4,e_y(a4)
\a:
        cmp.w   #110<<4,d2
        bne.s   \b
        GETSPR  artillery_2,e_image(a4)
        addq.w  #2,e_misc(a4)
        sub.w   #2<<4,e_y(a4)
\b:
        move.w  d2,e_x(a4)
        bne.s   \ok
        clr.w   (a4)
\q:     rts

\ok:    move.w  d2,d3
        and.w   #31<<3,d3
        bne.s   \q

        move.w  e_misc(a4),d0
        mulu    #10,d0
        lea     \shoot_types(pc,d0.w),a1
        bra     Fire_Generic_Bullet

\shoot_types:
        dc.w    EB_SIMPLE,4,0<<4,4,3<<4,4,spbullet_1-Draw_Sprite,0,-32,0
        dc.w    EB_SIMPLE,4,2<<4,4,-1<<4,4,spbullet_1-Draw_Sprite,0,-28,-12
        dc.w    EB_SIMPLE,4,7<<4,4,0<<4,4,spbullet_1-Draw_Sprite,0,-16,-16

*************************************** WOBBLING ENEMY ON ENTRY ARC

E_CIRCLING_ENTRY:
        move.w  e_misc(a4),d0
        cmp.w   #128,d0
        beq.s   \next
        lea     sines_table(pc),a0
        add.w   d0,a0
        addq.w  #2,d0
        move.w  d0,e_misc(a4)

        move.w  128(a0),d0              ; D0 = cosine
        asr.w   #2,d0
        add.w   e_x2(a4),d0
        move.w  d0,e_x(a4)

        move.w  (a0),d1                 ; D1 = sine
        asr.w   #2,d1
        move.w  e_y2(a4),d0
        sub.w   #1024,d0
        add.w   d1,d0
        move.w  d0,e_y(a4)
        rts

\next:  move.w  #CIRCLING_SLOW,(a4)
        move.w  #-26,e_misc(a4)

*************************************** WOBBLING ENEMY SLOWING INTO POSITION

E_CIRCLING_SLOW:
        move.w  e_misc(a4),d0
        addq.w  #1,d0
        move.w  d0,e_misc(a4)
        cmp.w   #-2,d0
        beq.s   \next
        add.w   d0,e_x(a4)
        rts

\next:  move.w  #CIRCLING_MAIN,(a4)
        clr.w   e_misc(a4)

*************************************** WOBBLING ENEMY SLOWLY CROSSING SCREEN

E_CIRCLING_MAIN:
        move.w  e_misc(a4),d0
        addq.w  #4,d0
        bclr    #9,d0
        move.w  d0,e_misc(a4)
        lea     sines_table(pc),a0
        move.w  0(a0,d0.w),d1
        asr.w   #4,d1
        add.w   e_y2(a4),d1
        move.w  d1,e_y(a4)
        subq.w  #2,e_x(a4)
        ble.s   \kill

        move.w  d7,d0
        mulu    d0,d0
        and.w   #127,d0
        move.w  game_timer(a5),d1
        and.w   #127,d1
        cmp.w   d0,d1
        bne.s   \q
        lea     enemy_2_shot(pc),a1
        bra     Fire_Generic_Bullet

\kill:  clr.w   (a4)
\q:     rts

*************************************** SMALL BASE

E_BASE: tst.w   open_space(a5)
        bne.s   \s
        sub.w   #16,e_x(a4)
\s:     move.w  game_timer(a5),d0
        and.w   #31,d0
        bne.s   rts1
        lea     base_shot(pc),a1
        bsr     Fire_Generic_Bullet

Aim_Bullet:
        lea     -eb_size(a0),a0

        move.w  player_xc(a5),d0
        sub.w   eb_x(a0),d0
        add.w   #64,d0
        move.w  d0,d5
        asr.w   #5,d0
        addq.w  #1,d0
        muls    d0,d0

        move.w  player_yc(a5),d1
        sub.w   eb_y(a0),d1
        add.w   #128,d1
        move.w  d1,d6
        asr.w   #5,d1
        muls    d1,d1
        add.w   d1,d0

        bsr     Square_Root_D0

        ext.l   d5
        divs    d2,d5
        move.w  d5,eb_xv(a0)
        ext.l   d6
        divs    d2,d6
        move.w  d6,eb_yv(a0)

rts1:   rts

base_shot:
        dc.w    EB_SIMPLE,4,3<<4,4,3<<4,4,spbullet_1-Draw_Sprite

*************************************** BASE GUARD (GENERIC ROUTINES)

Base_Guard:
        tst.w   open_space(a5)          ; go left if scrolling
        bne.s   \n
        sub.w   #16,e_x(a4)

\n:     move.w  game_timer(a5),d0       ; cycle image
        and.w   #3,d0
        bne.s   \q
        bsr     Next_Sprite
        bge.s   \q
        GETSPR  spin_0a,e_image(a4)
\q:     rts

*************************************** BASE GAURD (ENTERING)

E_GUARD_ENTRY:
        move.w  e_y(a4),d0
        cmp.w   e_y2(a4),d0
        beq.s   \next
        add.w   #32,e_y(a4)
        bra.s   Base_Guard

\next:  move.w  #GUARD_CIRCLING,(a4)

*************************************** BASE GUARD (CIRCLING)

E_GUARD_CIRCLING:
        bsr     \get_offset             ; undo circle offset
        sub.w   d0,e_x(a4)
        sub.w   d1,e_y(a4)
        bsr.s   Base_Guard              ; do standard movement
        addq.w  #4,e_misc(a4)           ; add new circle offset
        bsr     \get_offset
        add.w   d0,e_x(a4)
        add.w   d1,e_y(a4)

        moveq   #70,d0                  ; fire 1/70 of the time
        bsr     random
        tst.w   d0
        bne.s   \q

        lea     \shot(pc),a1
        bra     Fire_Generic_Bullet

\get_offset:                            ; compute position in circle
        move.w  e_misc(a4),d0
        bsr     sin_cos
        neg.w   d0
        asr.w   #3,d0
        asr.w   #3,d1
\q:     rts

\shot:  dc.w    EB_SIMPLE,3,0<<4,4,3<<4,4,spbullet_1-Draw_Sprite,0,-32,0

*************************************** FIRST TYPE OF BOSS

E_BOSS1:
        moveq   #80,d0
        bsr     random
        tst.w   d0
        bne.s   \no_center_shoot
        not.w   e_path(a4)
        moveq   #5,d0
        and.w   e_path(a4),d0
        add.w   #10<<4,d0
        lea     \ball_shot(pc),a1
        move.w  d0,8(a1)
        bsr     Fire_Generic_Bullet
        bsr     Aim_Bullet
\no_center_shoot:

        tst.w   e_timer(a4)             ; shoot lightning
        beq.s   \ready_to_shoot
        subq.w  #1,e_timer(a4)
        bra.s   \lightning_done
\ready_to_shoot:
        move.w  player_yc(a5),d0
        sub.w   e_y(a4),d0
        asr.w   #4,d0
        add.w   #19,d0
        ble.s   \lightning_done
        cmp.w   #45,d0
        bge.s   \lightning_done
        lea     \lightning(pc),a1
        clr.w   8(a1)
        cmp.w   #23,d0
        blt.s   \no_below
        move.w  #21<<4,8(a1)
\no_below:
        bsr     Fire_Generic_Bullet
        move.w  #40,e_timer(a4)
\lightning_done:

        tst.w   open_space(a5)          ; scroll left with space
        bne.s   \n
        sub.w   #16,e_x(a4)
\n:
        move.w  e_misc(a4),d0           ; move up/down
        add.w   d0,e_y(a4)
        cmp.w   #160<<4,e_y(a4)
        bge.s   \force_up
        cmp.w   #70<<4,e_y(a4)
        ble.s   \force_down
        moveq   #70,d0
        bsr     random
        tst.w   d0
        bne.s   \q
        neg.w   e_misc(a4)
\q:     rts

\force_up:
        move.w  #-16,e_misc(a4)
        rts

\force_down:
        move.w  #16,e_misc(a4)
        rts

\lightning:
        dc.w    EB_SIMPLE,6,-2<<4,13,0,6,splightning-Draw_Sprite,0,-64,0

\ball_shot:
        dc.w    EB_SIMPLE,4,0,4,3<<4,4,spbullet_1-Draw_Sprite

*************************************** FIND THE NEXT SPRITE INDEX
*
* Take a sprite index at the object in (A4) as input.  Advances this index to
* point to the following sprite, and tests the value here (which can help to
* see if it is a -1 indicating the end of the list).  Changes D0, A0, D1.
*
********

Next_Sprite:
        move.w  e_image(a4),d0
        lea     Draw_Sprite(pc),a0
        move.w  0(a0,d0.w),d1
        lsl.w   #3,d1
        add.w   #10,d1
        add.w   d1,d0
        move.w  d0,e_image(a4)
        tst.w   0(a0,d0.w)
        rts

*************************************** ENEMY TYPES
*
* The ETYPE macro assigns an eneny type value to each type of enemy in the
* game.  The only argument is the enemy "name"; this symbol is assigned to
* the offset of the enemy's code, which is at E_name.  This enemy type is a
* relative pointer to the enemy's code.
*
* As this table is only used to set symbols to equal the offsets, this table
* takes \absolutely no space in the executable code.
*
********

ETYPE   MACRO   
\1      equ     E_\1-Move_Enemies   
        ENDM    

        ETYPE   ARTILLERY
        ETYPE   ENEMY_2
        ETYPE   EXPLODING
        ETYPE   CIRCLING_ENTRY
        ETYPE   CIRCLING_SLOW
        ETYPE   CIRCLING_MAIN
        ETYPE   BASE
        ETYPE   GUARD_ENTRY
        ETYPE   GUARD_CIRCLING
        ETYPE   ENEMY_3
        ETYPE   BOSS1
        ETYPE   ENEMY_4_ENTERING
        ETYPE   ENEMY_4_MAIN
        ETYPE   HEAVY_CANNON
