****************************************************************************
****************************************************************************
**                                                               
**  Mercury for TI-89 / TI-92 Plus
**
**  This software is in the public domain.  There is no warranty.
**
**  by Patrick Davidson (pad@calc.org, http://pad.calc.org/)
**
**  Last updated May 8, 2002
**
****************************************************************************
****************************************************************************

        INCLUDE os.h

        XDEF    _main
        XDEF    _nostub

        INCLUDE which.i
        INCLUDE version.i
        INCLUDE mercury.i

        INCLUDE init.asm

        INCLUDE sprites\sprites.i

*************************************** SET UP DATA / SCREEN LAYOUT

main_game:
        bsr     Set_Up_Screen

        tst.w   saved_game(a5)
        bne     Resume_Saved

        lea     data_start(a5),a0
        move.w  #(data_end-data_start)/2-1,d0
\cd:    clr.w   (a0)+
        dbra    d0,\cd

*************************************** TITLE SCREEN / INITIALIZATION

        bsr     Title_Screen

        bsr     Zero_Foreground
    IFD ti89
        move.w  #48,screenx(a5)
    ENDIF
    IFND ti89
        move.w  #16,screenx(a5)
        move.w  #64,screeny(a5)
    ENDIF
        move.w  #50<<4,player_xc(a5)
        move.w  #118<<4,player_yc(a5)
        move.w  #17,player_w(a5)
        move.w  #20,player_h(a5)
        GETSPR  player_ship_1,player_image(a5)
        move.l  #$100,player_dmg-2(a5)

        move.w  #-16,fg_x(a5)

       ; move.w  #35<<4,fg_x(a5)

*************************************** MAIN LOOP

main_loop:      
        addq.w  #1,game_timer(a5)
        bsr     Enemy_Collisions
        bsr     Scroll_Screen
        bsr     Adjust_Contrast
        bsr     Draw_Player
        bsr     Move_Enemies
        bsr     Draw_Enemies
        bsr     Enemy_Bullets
        bsr     Player_Bullets
        bsr     Wait_VBL
        BSR     Display_Game_Screen     ; Copy buffer to actual screen

        bsr     Read_All_Keys 
        GETKEY  5,0,7,6                 ; Test APPS
        beq     save_game
        GETKEY  3,0,9,6                 ; Test status of . key 
        beq.s   game_done
        tst.w   player_dmg(a5)
        bge.s   main_loop

game_done:
        rts

*************************************** RESUME A SAVED GAME

Resume_Saved:
        clr.w   saved_game(a5)
        bsr     Redraw_Foreground
        bsr     Redraw_Background
        bra.s   main_loop

*************************************** SAVE THE GAME

save_game:
        st      saved_game(a5)
        bra.s   game_done

*************************************** CONTRAST SELECTION

Adjust_Contrast:
        GETEDGE 1,1,8,4                 ; +
        bne.s   \nocup
        JSR_ROM OSContrastUp
\nocup: GETEDGE 1,2,9,0                 ; -
        bne.s   \nocdn        
        JSR_ROM OSContrastDn
\nocdn: rts

*************************************** INCLUDE SUBROUTINE FILES

    IFD ti89
        INCLUDE disp89.asm
    ENDIF
    IFND ti89
        INCLUDE disp92.asm
    ENDIF
        INCLUDE ebullets.asm
        INCLUDE lib.asm
        INCLUDE back.asm
        INCLUDE startup.asm     
        INCLUDE gray.asm
        INCLUDE drawspr.asm
        INCLUDE player.asm
        INCLUDE enemies.asm
        INCLUDE enemies2.asm
        INCLUDE levels.asm
        INCLUDE eshoot.asm
        INCLUDE collide.asm
        INCLUDE bullets.asm
        INCLUDE hitenemy.asm
        INCLUDE title.asm
        INCLUDE vars.asm

        END     
