****************************************************************************
****************************************************************************
**                                                               
**  Mercury (Player handling routines)
**
**  This software is in the public domain.  There is no warranty.
**
**  by Patrick Davidson (pad@calc.org, http://pad.calc.org/)
**
**  Last updated May 17, 2002
**
****************************************************************************
****************************************************************************

MAX_X   set     80<<4
    IFD ti89
MIN_X   set     48<<4
    ENDIF
    IFND ti89
MIN_X   set     16<<4
    ENDIF
MIN_Y   set     64<<4     
MAX_Y   equ     MIN_Y+(108<<4)

******************************************** DRAW THE PLAYER'S SHIP

Draw_Player:
        move.w  player_xc(a5),d0        ; Load coordinates
        move.w  player_yc(a5),d1        
        moveq   #32,d2

        GETKEY  0,2,0,7                 ; Move down
        bne.s   player_notgoingdown     
        add.w   d2,d1     
        cmp.w   #MAX_Y,d1   
        ble.s   player_notgoingdown     
        move.w  #MAX_Y,d1

player_notgoingdown:

        GETKEY  0,0,0,5                 ; Move up
        bne.s   player_notgoingup       
        sub.w   d2,d1     
        cmp.w   #MIN_Y,d1       
        bge.s   player_notgoingup       
        move.w  #MIN_Y,d1       
player_notgoingup:

        GETKEY  0,3,0,6                 ; Move right
        bne.s   player_notgoingright    
        add.w   d2,d0     
        cmp.w   #MAX_X,d0   
        ble.s   player_notgoingright    
        move.w  #MAX_X,d0
player_notgoingright:

        GETKEY  0,1,0,4                 ; Move left
        bne.s   player_notgoingleft     
        sub.w   d2,d0     
        cmp.w   #MIN_X,d0       
        bge.s   player_notgoingleft     
        move.w  #MIN_X,d0       
player_notgoingleft:

        move.w  d0,player_xc(a5)
        move.w  d1,player_yc(a5)
    IFD ti89
        asr.w   #4,d1
        sub.w   #39,d1
        cmp.w   #64,d1
        bge.s   \a
        moveq   #64,d1
\a:     cmp.w   #97,d1
        ble.s   \b
        moveq   #97,d1
\b:     move.w  d1,screeny(a5)
        move.w  player_yc(a5),d1
    ENDIF

        move.w  player_image(a5),d2
        bsr     Draw_Sprite_D2

        bsr     Check_Foreground_Collision
      ;  bra.s   \nohit
        beq.s   \nohit
        lea     one(pc),a0
        lea     player_dmg+2(a5),a1
        moveq   #1,d5
        bsr     Sub_BCD
\nohit:

        tst.w   firecounter(a5)         ; decrement fire delay
        beq.s   \ready
        subq.w  #1,firecounter(a5)
\r:     rts

\ready: GETKEY  0,4,0,3                 ; Test 2nd/lock (fire)
        bne.s   \r

        lea     bullets_data(a5),a0     
        moveq   #num_b-1,d0    
loop_find_bullet:
        tst.w   (a0)    
        beq.s   found_bullet    
        lea     b_size(a0),a0   
        dbra    d0,loop_find_bullet
        rts

found_bullet:
        move.w  #4,firecounter(a5)   
        move.w  #PB_SIMPLE,(a0)+        ; b_type
        move.w  #3,(a0)+                ; b_dmg
        move.w  player_xc(a5),d0
        add.w   #10<<4,d0
        move.w  d0,(a0)+                ; b_x
        move.w  #9,(a0)+                ; b_w
        move.w  player_yc(a5),d0
        add.w   #7<<4,d0
        move.w  d0,(a0)+                ; b_y
        move.w  #6,(a0)+                ; b_h
        GETSPR  pbullet_1,(a0)+         ; b_image
        rts

        dc.b    $00,$01
one:

******************************************** TESTING PLAYER TO FOREGROUND

Check_Foreground_Collision:
        lea     Draw_Sprite(pc),a0
        add.w   player_image(a5),a0     ; A0 -> player ship image

        move.w  player_xc(a5),d0
        asr.w   #4,d0
        sub.w   screenx(a5),d0          ; D0 = X pixel coordinate
        move.w  d0,d2
        asr.w   #4,d2
        add.w   d2,d2                   ; D2 = X pixel word offset

        move.w  player_yc(a5),d1
        asr.w   #4,d1
        sub.w   #64,d1                  ; D1 = Y pixel coordinate

        move.l  backbuffer(a5),a1
        add.w   d2,a1
        mulu    #BUFFER_WIDTH,d1
        add.w   d1,a1                   ; A1 -> position on foreground

        move.w  (a0)+,d4                ; D4 = height - 1

        and.w   #15,d0                  ; D0 = low 4 bits of X coordinate
        subq.w  #8,d0

        bgt.s   \right
        beq.s   \cent    

\left:  neg.w   d0      
\leftloop:
        move.l  (a0)+,d1
        lsl.l   d0,d1
        move.l  d1,d2
        and.l   BUFFER_SIZE(a1),d2
        bne.s   \rts
        and.l   (a1),d1
        lea     BUFFER_WIDTH(a1),a1       
        dbra    d4,\leftloop
        rts

\cent:  move.l  (a0)+,d1
        move.l  d1,d2
        and.l   BUFFER_SIZE(a1),d2
        bne.s   \rts
        and.l   (a1),d1
        lea     BUFFER_WIDTH(a1),a1       
        dbra    d4,\cent
        rts

\right: move.l  (a0)+,d1
        lsr.l   d0,d1
        move.l  d1,d2
        and.l   BUFFER_SIZE(a1),d2
        bne.s   \rts
        and.l   (a1),d1
        lea     BUFFER_WIDTH(a1),a1       
        dbra    d4,\right                
\rts:   rts     
